	org 60000

; data tables for use with IX

qwerty:	; LD IX,60000 - lobyte 96, hibyte 234
	defw 19106	; position of A
	defw 21040	; position of B
	defw 21034	; position of C
	defw 19112	; position of D
	defw 18983	; position of E
	defw 19115	; position of F
	defw 19118	; position of G
	defw 19121	; position of H
	defw 18998	; position of I
	defw 19124	; position of J
	defw 19127	; position of K
	defw 19130	; position of L
	defw 21046	; position of M
	defw 21043	; position of N
	defw 19001	; position of O
	defw 19004	; position of P
	defw 18977	; position of Q
	defw 18986	; position of R
	defw 19109	; position of S
	defw 18989	; position of T
	defw 18995	; position of U
	defw 21037	; position of V
	defw 18980	; position of W
	defw 21031	; position of X
	defw 18992	; position of Y
	defw 21028	; position of Z
	defw 17056	; position of 1
	defw 17059	; position of 2
	defw 17062	; position of 3
	defw 17065	; position of 4
	defw 17068	; position of 5
	defw 17071	; position of 6
	defw 17074	; position of 7
	defw 17077	; position of 8
	defw 17080	; position of 9
	defw 17083	; position of 0
	defw 21281	; position of CAPS SHIFT
	defw 21305	; position of SYMBOL SHIFT
	defw 21308	; position of SPACE
	defw 19389	; position of ENTER

; use 016957 as a generic position until they're all done
; or 017210 for the control keys
; the leading 0 shows it's "wrong"

dvorak:	; LD IX,60080 - lobyte 176, hibyte 234

	defw 19106	; position of A
	defw 21043	; position of B
	defw 18998	; position of C
	defw 19121	; position of D
	defw 19112	; position of E
	defw 18992	; position of F
	defw 18995	; position of G
	defw 19124	; position of H
	defw 19118	; position of I
	defw 21034	; position of J
	defw 21037	; position of K
	defw 19004	; position of L
	defw 21046	; position of M
	defw 19130	; position of N
	defw 19109	; position of O
	defw 18986	; position of P
	defw 21031	; position of Q
	defw 19001	; position of R
	defw 19133	; position of S
	defw 19127	; position of T
	defw 19115	; position of U
	defw 21052	; position of V
	defw 21049	; position of W
	defw 21040	; position of X
	defw 18989	; position of Y
	defw 21028	; position of Z
	defw 17056	; position of 1
	defw 17059	; position of 2
	defw 17062	; position of 3
	defw 17065	; position of 4
	defw 17068	; position of 5
	defw 17071	; position of 6
	defw 17074	; position of 7
	defw 17077	; position of 8
	defw 17080	; position of 9
	defw 17083	; position of 0
	defw 19236	; position of CAPS SHIFT
	defw 19239	; position of SYMBOL SHIFT
	defw 21281	; position of SPACE
	defw 19233	; position of ENTER

dvorak_l: ; LD IX,60160 - lobyte 0, hibyte 235
	defw 19124	; position of A
	defw 18980	; position of B
	defw 19109	; position of C
	defw 19112	; position of D
	defw 19121	; position of E
	defw 17065	; position of F
	defw 21031	; position of G
	defw 19118	; position of H
	defw 21043	; position of I
	defw 17074	; position of J
	defw 19106	; position of K
	defw 17071	; position of L
	defw 17068	; position of M
	defw 21040	; position of N
	defw 18995	; position of O
	defw 17062	; position of P
	defw 18977	; position of Q
	defw 18989	; position of R
	defw 18992	; position of S
	defw 19115	; position of T
	defw 18986	; position of U
	defw 21034	; position of V
	defw 21037	; position of W
	defw 21028	; position of X
	defw 18983	; position of Y
	defw 19127	; position of Z
	defw 21046	; position of 1
	defw 17083	; position of 2
	defw 17080	; position of 3
	defw 17077	; position of 4
	defw 19004	; position of 5
	defw 19001	; position of 6
	defw 19133	; position of 7
	defw 19130	; position of 8
	defw 21052	; position of 9
	defw 21049	; position of 0
	defw 17315	; position of CAPS SHIFT
	defw 19254	; position of SYMBOL SHIFT
	defw 21281	; position of SPACE
	defw 17312	; position of ENTER

dvorak_r: ; LD IX,60240 - lobyte 80, hibyte 235
	defw 19115	; position of A
	defw 19004	; position of B
	defw 19130	; position of C
	defw 19127	; position of D
	defw 19118	; position of E
	defw 17077	; position of F
	defw 21052	; position of G
	defw 19121	; position of H
	defw 21040	; position of I
	defw 17068	; position of J
	defw 19133	; position of K
	defw 17071	; position of L
	defw 17074	; position of M
	defw 21043	; position of N
	defw 18989	; position of O
	defw 17080	; position of P
	defw 18983	; position of Q
	defw 18992	; position of R
	defw 18995	; position of S
	defw 19124	; position of T
	defw 18998	; position of U
	defw 21049	; position of V
	defw 21046	; position of W
	defw 21034	; position of X
	defw 19001	; position of Y
	defw 19112	; position of Z
	defw 17056	; position of 1
	defw 17059	; position of 2
	defw 17062	; position of 3
	defw 17065	; position of 4
	defw 18977	; position of 5
	defw 18980	; position of 6
	defw 19106	; position of 7
	defw 19109	; position of 8
	defw 21028	; position of 9
	defw 21031	; position of 0
	defw 21293	; position of CAPS SHIFT
	defw 19242	; position of SYMBOL SHIFT
	defw 21281	; position of SPACE
	defw 17339	; position of ENTER

; character data A-Z at 60320 - 24 bytes each

data_a:	defb 0,96,0,240,0,240,1,248,1,152,3,156
	defb 3,12,7,14,7,254,15,255,12,3,12,3
data_b:	defb 15,252,15,254,12,7,12,3,12,7,15,254
	defb 15,254,12,7,12,3,12,7,15,254,15,252
data_c:	defb 3,252,7,254,14,7,12,3,12,0,12,0
	defb 12,0,12,0,12,3,14,7,7,254,3,252
data_d:	defb 15,248,15,252,12,14,12,7,12,3,12,3
	defb 12,3,12,3,12,7,12,14,15,252,15,248
data_e:	defb 15,255,15,255,12,0,12,0,12,0,15,252
	defb 15,252,12,0,12,0,12,0,15,255,15,255
data_f:	defb 15,255,15,255,12,0,12,0,12,0,15,252
	defb 15,252,12,0,12,0,12,0,12,0,12,0
data_g:	defb 3,252,7,254,14,7,12,3,12,0,12,0
	defb 12,63,12,63,12,3,14,7,7,254,3,252
data_h:	defb 12,3,12,3,12,3,12,3,12,3,15,255
	defb 15,255,12,3,12,3,12,3,12,3,12,3
data_i:	defb 3,252,3,252,0,96,0,96,0,96,0,96
	defb 0,96,0,96,0,96,0,96,3,252,3,252
data_j:	defb 0,3,0,3,0,3,0,3,0,3,0,3
	defb 12,3,12,3,12,3,14,7,7,254,3,252
data_k:	defb 12,12,12,28,12,56,12,112,15,224,15,224
	defb 12,112,12,56,12,28,12,14,12,7,12,3
data_l:	defb 12,0,12,0,12,0,12,0,12,0,12,0
	defb 12,0,12,0,12,0,12,0,15,255,15,255
data_m:	defb 12,3,14,7,14,7,15,15,15,15,15,159
	defb 13,155,13,251,12,243,12,243,12,99,12,99
data_n:	defb 12,3,14,3,15,3,15,131,13,195,12,227
	defb 12,115,12,59,12,31,12,15,12,7,12,3
data_o:	defb 3,252,7,254,14,7,12,3,12,3,12,3
	defb 12,3,12,3,12,3,14,7,7,254,3,252
data_p:	defb 15,252,15,254,12,7,12,3,12,3,12,7
	defb 15,254,15,252,12,0,12,0,12,0,12,0
data_q:	defb 3,252,7,254,14,7,12,3,12,3,12,3
	defb 12,51,12,59,12,31,14,14,7,255,3,251
data_r:	defb 15,252,15,254,12,7,12,3,12,3,12,7
	defb 15,254,15,252,12,28,12,14,12,7,12,3
data_s:	defb 3,252,7,254,14,7,12,3,14,0,7,252
	defb 3,254,0,7,12,3,14,7,7,254,3,252
data_t:	defb 15,255,15,255,0,96,0,96,0,96,0,96
	defb 0,96,0,96,0,96,0,96,0,96,0,96
data_u:	defb 12,3,12,3,12,3,12,3,12,3,12,3
	defb 12,3,12,3,12,3,14,7,7,254,3,252
data_v:	defb 12,3,12,3,14,7,6,6,7,14,3,12
	defb 3,156,1,152,1,248,0,240,0,240,0,96
data_w:	defb 12,3,12,3,12,99,12,99,14,247,6,246
	defb 7,254,7,254,7,158,3,156,3,12,3,12
data_x:	defb 12,3,14,7,7,14,3,156,1,248,0,240
	defb 0,240,1,248,3,156,7,14,14,7,12,3
data_y:	defb 12,3,14,7,7,14,3,156,1,248,0,240
	defb 0,96,0,96,0,96,0,96,0,96,0,96
data_z:	defb 15,255,15,255,0,14,0,28,0,56,0,112
	defb 0,224,1,192,3,128,7,0,15,255,15,255

; character data 0-9 at 60944 - 24 bytes each

data_1:	defb 0,224,1,224,3,224,7,96,6,96,0,96
	defb 0,96,0,96,0,96,0,96,7,254,7,254
data_2:	defb 3,252,7,254,14,7,12,3,0,3,0,7
	defb 3,254,7,252,14,0,12,0,15,255,15,255
data_3:	defb 3,252,7,254,14,7,12,3,0,7,0,62
	defb 0,62,0,7,12,3,14,7,7,254,3,252
data_4:	defb 0,12,0,28,0,60,0,124,0,236,1,204
	defb 3,140,7,12,15,255,15,255,0,12,0,12
data_5:	defb 15,255,15,255,12,0,12,0,15,252,15,254
	defb 0,7,0,3,12,3,14,7,7,254,3,252
data_6:	defb 3,252,7,252,14,0,12,0,15,252,15,254
	defb 12,7,12,3,12,3,14,7,7,254,3,252
data_7:	defb 15,255,15,255,0,3,0,7,0,14,0,28
	defb 0,56,0,112,0,224,1,192,3,128,3,0
data_8:	defb 3,252,7,254,14,7,12,3,14,7,7,254
	defb 7,254,14,7,12,3,14,7,7,254,3,252
data_9:	defb 3,252,7,254,14,7,12,3,12,3,14,3
	defb 7,255,3,255,0,3,0,7,3,254,3,252
data_0:	defb 3,252,7,254,14,15,12,31,12,59,12,115
	defb 12,227,13,195,15,131,15,7,7,254,3,252

; control keys data at 61184 - 33 bytes each

data_caps:	defb 25,49,143,33,42,15,34,177,15,35,160,143,26,163,15
		defb 0,0,15
		defb 26,173,207,34,168,143,19,172,143,10,168,143,50,168,143
data_symb:	defb 26,171,15,34,186,143,17,59,15,9,42,143,49,43,15
		defb 0,0,15
		defb 26,173,207,34,168,143,19,172,143,10,168,143,50,168,143
data_space:	defb 0,0,15,0,0,15,0,0,15
		defb 54,70,239,69,72,143,38,168,239,20,232,143,100,166,239
		defb 0,0,15,0,0,15,0,0,15
data_enter:	defb 0,0,15,0,0,15,0,0,15
		defb 105,118,207,77,36,175,107,38,207,73,36,175,105,38,175
		defb 0,0,15,0,0,15,0,0,15

print_pos:	defb 5,0
		defb 9,1
		defb 13,2
		defb 17,1

; now we start - USR 61324 (kb)

	ld ix,60000	; address of table of positions - POKE value to kb+2/kb+3

; print keys

	ld a,2
	call 5633	; now PRINTing to screen

	ld hl,23695	; ATTR_T (need to use the temporary colours)
	ld (hl),56	; PAPER 7, INK 0, BRIGHT 0, FLASH 0

	ld hl,print_pos	; HL now set up to point to the print positions

	ld b,4
keyloop1:
	ld d,(hl)
	inc hl
	ld e,(hl)	; start position set
	inc hl		; HL now points at the PRINT AT position for next time
	ld a,22
	rst 16
	ld a,d
	rst 16
	ld a,e
	rst 16		; PRINT AT position set for top row
	call printhalfkeys
	ld a,22
	rst 16
	ld a,d
	inc a
	rst 16
	ld a,e
	rst 16		; PRINT AT position set for bottom row
	call printhalfkeys
	djnz keyloop1

; print the letters and numbers

	ld hl,data_a	; set HL to start of data for the letters

	ld b,36		; print characters A-Z and 0-9 in their respective positions

charloop:
	; print first row at (IX) and (IX)+1
	; IX points to a two-byte value - hold this value in DE
	ld e,(ix+0)	; put the low byte in E
	ld d,(ix+1)	; put the high byte in D

	call printchar	; print the top 6 lines of the character
	; after this loop, now need to adjust DE again to get it onto the correct line
	; DE is at 20642 now after the top half of "A" - needs to be 18626
	; so subtract 2016
	push hl
	ex de,hl
	ld de,63520	; "LD DE,-2016"to use ADD instead of SBC
	add hl,de	; correctly adjusted value is now in HL
	ex de,hl	; correctly adjusted value is now in DE
	pop hl		; and get HL back
	call printchar	; print the bottom 6 lines of the character

	; now move IX onto the next data value which is TWO bytes further on
	inc ix
	inc ix

	djnz charloop

; At the end of this process:
; IX = 60072 - contains position of CAPS SHIFT
; HL = 61184 - start of data for CAPS SHIFT
; now need to print the control keys

	ld b,4

ctrlloop:
	; print first row at (IX) and (IX)+1
	; IX points to a two-byte value - hold this value in DE
	ld e,(ix+0)	; put the low byte in E
	ld d,(ix+1)	; put the high byte in D

	push bc
	ld b,5
ctrltoploop:
	call printctrl	; print the top 5 lines of the character
	djnz ctrltoploop
	pop bc

	; after this loop, now need to adjust DE again to get it onto the correct line
	; DE is at 20642 now after the top half of "A" - needs to be 18626
	; so subtract 2016
	push hl
	ex de,hl
	ld de,63520	; "LD DE,-2016"to use ADD instead of SBC
	add hl,de	; correctly adjusted value is now in HL
	ex de,hl	; correctly adjusted value is now in DE
	pop hl		; and get HL back

	push bc
	ld b,6
ctrlbottomloop:
	call printctrl	; print the bottom 6 lines of the character
	djnz ctrlbottomloop
	pop bc

	; now move IX onto the next data value which is TWO bytes further on
	inc ix
	inc ix

	djnz ctrlloop
	ret


;	defb 221,68	; ld b,ixh
;	defb 221,77	; ld c,ixl



; SUBROUTINES

printhalfkeys:
	push bc		; make sure to store any old loop variable
	ld b,10		; PRINT 3 characters 10 times in succession
keyloop2:
	ld a,32
	rst 16
	ld a,32
	rst 16
	ld a,133
	rst 16		; PRINTs two spaces and a graphic 5 - half of the key
	djnz keyloop2
	pop bc		; get the old loop variable back
	ret

printchar:
	push bc		; make sure to store any old loop variable
	ld b,6		; need to loop 6 times to print the top half of the character
printcharloop:
	ld a,(hl)	; fill A with the first value
	ld (de),a	; fill the screen position (DE) - equal to (IX) - with A
	inc hl		; move HL to the next value
	inc de		; move DE to the next value
	ld a,(hl)	
	ld (de),a	; one row is now complete
	inc hl		; move HL to the next value
	; need to increase DE by 255
	push hl		; store HL value
	ex de,hl	; value of DE is now in HL
	ld de,255
	add hl,de	; value we want is now in HL
	ex de,hl	; value we want is now in DE
	pop hl		; and get HL back
	djnz printcharloop
	pop bc		; get the old loop variable back
	ret

printctrl:
	ld a,(hl)	; fill A with the first value
	ld (de),a	; fill the screen position (DE) - equal to (IX) - with A
	inc hl		; move HL to the next value
	inc de		; move DE to the next value
	ld a,(hl)	
	ld (de),a	; second value filled
	inc hl
	inc de		; move DE to the next value
	ld a,(hl)	
	ld (de),a	; third value filled - this is always ****1111
	inc hl		; move HL to the next value
	; need to increase DE by 254
	push hl		; store HL value
	ex de,hl	; value of DE is now in HL
	ld de,254
	add hl,de	; value we want is now in HL
	ex de,hl	; value we want is now in DE
	pop hl		; and get HL back
	ret

; Address of last byte = 61499

; Address of first available byte = 61500

; These are more data tables for each keyboard layout

; Order for two-handed Dvorak (78 bytes, 61500-61577)
	defw 65022
		defb 190	; IN 65022 = 190: A pressed
	defw 32766
		defb 183	; IN 32766 = 183: N pressed
	defw 57342
		defb 187	; IN 57342 = 187: I pressed
	defw 49150
		defb 175	; IN 49150 = 175: H pressed
	defw 65022
		defb 187	; IN 65022 = 187: D pressed
	defw 57342
		defb 175	; IN 57342 = 175: Y pressed
	defw 57342
		defb 183	; IN 57342 = 183: U pressed
	defw 49150
		defb 183	; IN 49150 = 183: J pressed
	defw 65022
		defb 175	; IN 65022 = 175: G pressed
	defw 65278
		defb 183	; IN 65278 = 183: C pressed
	defw 65278
		defb 175	; IN 65278 = 175: V pressed
	defw 57342
		defb 190	; IN 57342 = 190: P pressed
	defw 32766
		defb 187	; IN 32766 = 187: M pressed
	defw 49150
		defb 189	; IN 49150 = 189: L pressed
	defw 65022
		defb 189	; IN 65022 = 189: S pressed
	defw 64510
		defb 183	; IN 64510 = 183: R pressed
	defw 65278
		defb 187	; IN 65278 = 187: X pressed
	defw 57342
		defb 189	; IN 57342 = 189: O pressed
	defw 49150
		defb 190	; IN 49150 = 190: Enter pressed
	defw 49150
		defb 187	; IN 49150 = 187: K pressed
	defw 65022
		defb 183	; IN 65022 = 183: F pressed
	defw 32766
		defb 190	; IN 32766 = 190: Space pressed
	defw 32766
		defb 189	; IN 32766 = 189: SShift pressed
	defw 32766
		defb 175	; IN 32766 = 175: B pressed
	defw 64510
		defb 175	; IN 64510 = 175: T pressed
	defw 65278
		defb 189	; IN 65278 = 189: Z pressed
	defb 0,0		; spacer

; Order for left-handed Dvorak (78 bytes, 61580-61657)
	defw 49150
		defb 183	; IN 49150 = 183: J pressed
	defw 64510
		defb 189	; IN 64510 = 189: W pressed
	defw 65022
		defb 189	; IN 65022 = 189: S pressed
	defw 65022
		defb 187	; IN 65022 = 187: D pressed
	defw 49150
		defb 175	; IN 49150 = 175: H pressed
	defw 63486
		defb 183	; IN 63486 = 183: 4 pressed
	defw 65278
		defb 187	; IN 65278 = 187: X pressed
	defw 65022
		defb 175	; IN 65022 = 175: G pressed
	defw 32766
		defb 183	; IN 32766 = 183: N pressed
	defw 61438
		defb 183	; IN 61438 = 183: 7 pressed
	defw 65022
		defb 190	; IN 65022 = 190: A pressed
	defw 61438
		defb 175	; IN 61438 = 175: 6 pressed
	defw 63486
		defb 175	; IN 63486 = 175: 5 pressed
	defw 32766
		defb 175	; IN 32766 = 175: B pressed
	defw 57342
		defb 183	; IN 57342 = 183: U pressed
	defw 63486
		defb 187	; IN 63486 = 187: 3 pressed
	defw 64510
		defb 190	; IN 64510 = 190: Q pressed
	defw 64510
		defb 175	; IN 64510 = 175: T pressed
	defw 57342
		defb 175	; IN 57342 = 175: Y pressed
	defw 65022
		defb 183	; IN 65022 = 183: F pressed
	defw 64510
		defb 183	; IN 64510 = 183: R pressed
	defw 65278
		defb 183	; IN 65278 = 183: C pressed
	defw 65278
		defb 175	; IN 65278 = 175: V pressed
	defw 65278
		defb 189	; IN 65278 = 189: Z pressed
	defw 64510
		defb 187	; IN 64510 = 187: E pressed
	defw 49150
		defb 187	; IN 49150 = 187: K pressed
	defb 0,0		; spacer
	
; Order for right-handed Dvorak (78 bytes, 61660-61737)	
	defw 65022
		defb 183	; IN 65022 = 183: F pressed
	defw 57342
		defb 190	; IN 57342 = 190: P pressed
	defw 49150
		defb 189	; IN 49150 = 189: L pressed
	defw 49150
		defb 187	; IN 49150 = 187: K pressed
	defw 65022
		defb 175	; IN 65022 = 175: G pressed
	defw 61438
		defb 187	; IN 61438 = 187: 8 pressed
	defw 32766
		defb 190	; IN 32766 = 190: Space pressed
	defw 49150
		defb 175	; IN 49150 = 175: H pressed
	defw 32766
		defb 175	; IN 32766 = 175: B pressed
	defw 63486
		defb 175	; IN 63486 = 175: 5 pressed
	defw 49150
		defb 190	; IN 49150 = 190: Enter pressed
	defw 61438
		defb 175	; IN 61438 = 175: 6 pressed
	defw 61438
		defb 183	; IN 61438 = 183: 7 pressed
	defw 32766
		defb 183	; IN 32766 = 183: N pressed
	defw 64510
		defb 175	; IN 64510 = 175: T pressed
	defw 61438
		defb 189	; IN 61438 = 189: 9 pressed
	defw 64510
		defb 187	; IN 64510 = 187: E pressed
	defw 57342
		defb 175	; IN 57342 = 175: Y pressed
	defw 57342
		defb 183	; IN 57342 = 183: U pressed
	defw 49150
		defb 183	; IN 49150 = 183: J pressed
	defw 57342
		defb 187	; IN 57342 = 187: I pressed
	defw 32766
		defb 189	; IN 32766 = 189: SShift pressed
	defw 32766
		defb 187	; IN 32766 = 187: M pressed
	defw 65278
		defb 183	; IN 65278 = 183: C pressed
	defw 57342
		defb 189	; IN 57342 = 189: O pressed
	defw 65022
		defb 187	; IN 65022 = 187: D pressed
	defb 0,0		; spacer
	
; TOP SECRET! Order for QWERTY (78 bytes, 61740-61817)	
; this is just regular alphabetical order, with the INs to correspond to that
	defw 65022
		defb 190	; IN 65022 = 190: A pressed
	defw 32766
		defb 175	; IN 32766 = 175: B pressed
	defw 65278
		defb 183	; IN 65278 = 183: C pressed
	defw 65022
		defb 187	; IN 65022 = 187: D pressed
	defw 64510
		defb 187	; IN 64510 = 187: E pressed
	defw 65022
		defb 183	; IN 65022 = 183: F pressed
	defw 65022
		defb 175	; IN 65022 = 175: G pressed
	defw 49150
		defb 175	; IN 49150 = 175: H pressed
	defw 57342
		defb 187	; IN 57342 = 187: I pressed
	defw 49150
		defb 183	; IN 49150 = 183: J pressed
	defw 49150
		defb 187	; IN 49150 = 187: K pressed
	defw 49150
		defb 189	; IN 49150 = 189: L pressed
	defw 32766
		defb 187	; IN 32766 = 187: M pressed
	defw 32766
		defb 183	; IN 32766 = 183: N pressed
	defw 57342
		defb 189	; IN 57342 = 189: O pressed
	defw 57342
		defb 190	; IN 57342 = 190: P pressed
	defw 64510
		defb 190	; IN 64510 = 190: Q pressed
	defw 64510
		defb 183	; IN 64510 = 183: R pressed
	defw 65022
		defb 189	; IN 65022 = 189: S pressed
	defw 64510
		defb 175	; IN 64510 = 175: T pressed
	defw 57342
		defb 183	; IN 57342 = 183: U pressed
	defw 65278
		defb 175	; IN 65278 = 175: V pressed
	defw 64510
		defb 189	; IN 64510 = 189: W pressed
	defw 65278
		defb 187	; IN 65278 = 187: X pressed
	defw 57342
		defb 175	; IN 57342 = 175: Y pressed
	defw 65278
		defb 189	; IN 65278 = 189: Z pressed

	
; In case these are needed again...
;	defw 65278
;		defb 190	; IN 65278 = 190: CShift pressed
;	defw 65278
;		defb 189	; IN 65278 = 189: Z pressed
;	defw 65278
;		defb 187	; IN 65278 = 187: X pressed
;	defw 65278
;		defb 183	; IN 65278 = 183: C pressed
;	defw 65278
;		defb 175	; IN 65278 = 175: V pressed
;	defw 65022
;		defb 190	; IN 65022 = 190: A pressed
;	defw 65022
;		defb 189	; IN 65022 = 189: S pressed
;	defw 65022
;		defb 187	; IN 65022 = 187: D pressed
;	defw 65022
;		defb 183	; IN 65022 = 183: F pressed
;	defw 65022
;		defb 175	; IN 65022 = 175: G pressed
;	defw 64510
;		defb 190	; IN 64510 = 190: Q pressed
;	defw 64510
;		defb 189	; IN 64510 = 189: W pressed
;	defw 64510
;		defb 187	; IN 64510 = 187: E pressed
;	defw 64510
;		defb 183	; IN 64510 = 183: R pressed
;	defw 64510
;		defb 175	; IN 64510 = 175: T pressed
;	defw 63486
;		defb 190	; IN 63486 = 190: 1 pressed
;	defw 63486
;		defb 189	; IN 63486 = 189: 2 pressed
;	defw 63486
;		defb 187	; IN 63486 = 187: 3 pressed
;	defw 63486
;		defb 183	; IN 63486 = 183: 4 pressed
;	defw 63486
;		defb 175	; IN 63486 = 175: 5 pressed
;	defw 61438
;		defb 190	; IN 61438 = 190: 0 pressed
;	defw 61438
;		defb 189	; IN 61438 = 189: 9 pressed
;	defw 61438
;		defb 187	; IN 61438 = 187: 8 pressed
;	defw 61438
;		defb 183	; IN 61438 = 183: 7 pressed
;	defw 61438
;		defb 175	; IN 61438 = 175: 6 pressed
;	defw 57342
;		defb 190	; IN 57342 = 190: P pressed
;	defw 57342
;		defb 189	; IN 57342 = 189: O pressed
;	defw 57342
;		defb 187	; IN 57342 = 187: I pressed
;	defw 57342
;		defb 183	; IN 57342 = 183: U pressed
;	defw 57342
;		defb 175	; IN 57342 = 175: Y pressed
;	defw 49150
;		defb 190	; IN 49150 = 190: Enter pressed
;	defw 49150
;		defb 189	; IN 49150 = 189: L pressed
;	defw 49150
;		defb 187	; IN 49150 = 187: K pressed
;	defw 49150
;		defb 183	; IN 49150 = 183: J pressed
;	defw 49150
;		defb 175	; IN 49150 = 175: H pressed
;	defw 32766
;		defb 190	; IN 32766 = 190: Space pressed
;	defw 32766
;		defb 189	; IN 32766 = 189: SShift pressed
;	defw 32766
;		defb 187	; IN 32766 = 187: M pressed
;	defw 32766
;		defb 183	; IN 32766 = 183: N pressed
;	defw 32766
;		defb 175	; IN 32766 = 175: B pressed


; 61818: routine to transfer "WELL DONE" in flashing ATTRS onto screen at 17,0
	ld hl,welldone
	ld de,23072
	ld bc,160
	ldir
	ret
	
; 61830: routine to store the top third of the screen above the end of this block (62384-64431)
	ld hl,16384
	ld de,62384
	ld bc,2048
	ldir
	ret

; 61842: routine to retrieve the top third of the screen above the end of this
	ld hl,62384
	ld de,16384
	ld bc,2048
	ldir
	ret

; 61854: data table for the "WELL DONE" routine (160 bytes):
welldone:
	defb 208,0,0,0,0,0,208,0,208,212,212,212,196,208,0,0,196,196,208,0,196,0,0,0,196,0,196,196,196,196,0,196
	defb 208,0,0,0,0,0,208,0,208,0,196,0,0,212,0,196,0,0,212,0,196,196,0,0,196,0,196,0,0,0,0,196
	defb 0,208,0,208,0,208,0,0,208,208,212,0,0,212,0,196,0,0,212,0,196,0,196,0,196,0,196,196,196,0,0,196
	defb 0,208,0,208,0,208,0,0,208,0,196,0,0,212,0,196,0,0,212,0,196,0,0,196,196,0,196,0,0,0,0,0
	defb 0,0,208,0,208,0,0,0,208,212,212,212,196,208,208,208,212,196,208,208,212,208,0,0,196,0,196,196,196,196,0,196

; last byte at 62013
